<template>
    <div class="bubble-reply q-pa-sm row" @click.stop="scrollToMessage">
        <div
            class="col"
            :class="
                repliedMessage?.thumbnail?.url ?? repliedMessage?.file?.url
                    ? 'q-mr-lg'
                    : ''
            "
        >
            <div class="sender-name">
                <q-icon class="q-mb-xs" name="reply" size="15px" />
            </div>
            <div class="reply-content" v-html="replyText" @click.stop></div>
        </div>
        <q-img
            no-spinner
            width="40px"
            height="40px"
            cover
            v-if="previewUrl"
            :src="previewUrl"
        />
    </div>
</template>

<script lang="ts">
import MessageController from '../../controller/MessageController';
import { MessageType } from 'src/services/enums/MessageType';
import { Message } from 'src/services/models/Message';
import { defineComponent, computed } from 'vue';
import { useStore } from 'src/store';

export default defineComponent({
    name: 'BubbleReply',
    props: {
        repliedMessage: {
            type: Object as () => Message,
            required: true
        }
    },
    setup(props) {
        const store = useStore();
        const { text, previewUrl, isSender } = MessageController(
            props.repliedMessage,
            true
        );

        const replyText = computed((): string => {
            let _text = text.value;
            const message = props.repliedMessage;

            // Check if text is empty
            if (
                _text == '' ||
                [
                    MessageType.STICKER,
                    MessageType.EVENT_REMINDER,
                    MessageType.DOCUMENT,
                    MessageType.AUDIO
                ].includes(parseInt(`${message?.type}`))
            ) {
                if (message?.type == MessageType.LIVE_LOCATION) {
                    _text = 'Live Location';
                } else if (message?.type == MessageType.EVENT_REMINDER) {
                    _text = 'Event Reminder';
                } else if (message?.type == MessageType.MOMENT) {
                    _text = 'Moment';
                } else if (message?.type == MessageType.POLL) {
                    _text = 'Poll';
                } else if (message?.type == MessageType.IMAGE) {
                    _text = 'Image';
                } else if (message?.type == MessageType.VIDEO) {
                    _text = 'Video';
                } else if (message?.type == MessageType.DOCUMENT) {
                    _text = 'Document';
                } else if (message?.type == MessageType.AUDIO) {
                    _text = 'Audio';
                } else if (message?.type == MessageType.GIF) {
                    _text = 'Gif';
                } else if (message?.type == MessageType.CONTACT) {
                    _text = 'Contact';
                } else if (message?.type == MessageType.LOCATION) {
                    _text = 'Location';
                } else if (message?.type == MessageType.STICKER) {
                    _text = 'Sticker';
                }

                // Italic the text
                _text = `<i>${_text}</i>`;
            }

            return _text;
        });

        const scrollToMessage = () => {
            const replyElement = document.getElementById(
                'message-' + props.repliedMessage.id
            );

            if (replyElement) {
                replyElement.classList.add('highlighted');
                replyElement.scrollIntoView({
                    behavior: 'smooth'
                });
                setTimeout(() => {
                    replyElement.classList.remove('highlighted');
                }, 2000);
            } else {
                store.dispatch('chat/setScroll', props.repliedMessage);
            }
        };

        return {
            replyText,
            scrollToMessage,
            previewUrl,
            isSender
        };
    }
});
</script>
